<template>
  <div
    class="main-content-wrap d-flex align-items-center flex-column main-wrapper secondsidenav-closed bg-white"
    :class="{'sidenav-open':isSidebarOpen}"
  >
    <div class="container bg-white py-3 px-5">
      <div class="row mb-4">
        <div class="col-md-6">
          <h3>Dashboard</h3>
        </div>
        <div class="col-md-6">
          <filter-bar class="float-right"></filter-bar>
        </div>
      </div>

      <div class="row mb-4">
        <div class="col-md-12">
          <div class="card bg-light shadow-md p-3">
            <area-chart :key="componentKey"></area-chart>
          </div>
        </div>
      </div>

      <div class="row mb-4">
        <div class="col-lg-3 col-md-6 col-sm-6">
          <div class="card border shadow-md bg-light">
            <div class="card-body d-flex">
              <div class="mr-auto px-2">
                <p class="text-primary text-24 mt-2 mb-0">{{totalConversation }}</p>
                <p class="text-muted text-12 line-height-1 mb-2">Conversations</p>
              </div>
              <img
                :src="asset('images/ui_elements/ic_daily_conversations.png')"
                class="logo-card-dashboard"
                style="width: 50pt"
                alt="daily conversations"
              >
            </div>
          </div>
        </div>
        <div class="col-lg-3 col-md-6 col-sm-6">
          <div class="card border shadow-md bg-light">
            <div class="card-body d-flex">
              <div class="mr-auto px-2">
                <p class="text-primary text-24 mt-2 mb-0">{{totalUser }}</p>
                <p class="text-muted text-12 line-height-1 mb-2">Users</p>
              </div>
              <img
                :src="asset('images/ui_elements/ic_failed_transactions.png')"
                class="logo-card-dashboard"
                alt="daily transactions"
              >
            </div>
          </div>
        </div>
        <div class="col-lg-3 col-md-6 col-sm-6">
          <div class="card border shadow-md bg-light">
            <div class="card-body d-flex">
              <div class="mr-auto px-2">
                <p class="text-primary text-24 mt-2 mb-0">{{totalTransaction}}</p>
                <p class="text-muted text-12 line-height-1 mb-2">Transaction</p>
              </div>
              <img
                :src="asset('images/ui_elements/ic_daily_transactions.png')"
                class="logo-card-dashboard"
                alt="failed transactions"
              >
            </div>
          </div>
        </div>
        <div class="col-lg-3 col-md-6 col-sm-6">
          <div class="card border shadow-md bg-light">
            <div class="card-body d-flex">
              <div class="mr-auto px-2">
                <p class="text-primary text-24 mt-2 mb-0">{{formatAmount(totalAmount)}}</p>
                <p class="text-muted text-12 line-height-1 mb-2">Amount</p>
              </div>
              <img
                :src="asset('images/ui_elements/ic_agent_takeover.png')"
                class="logo-card-dashboard"
                alt="agent takeover"
              >
            </div>
          </div>
        </div>
      </div>

      <div class="row mb-4">
        <div class="col-md-6">
          <div class="card bg-light shadow-md p-3">
            <pie-chart :key="componentKey"></pie-chart>
          </div>
        </div>
        <div class="col-md-6">
          <div class="card bg-light shadow-md p-3">
            <bar-chart :key="componentKey"></bar-chart>
          </div>
        </div>
      </div>

      <div class="row mb-4">
        <div class="col-md-6">
          <div class="card bg-light shadow-md" style="max-height:40vh;">
            <span class="p-3">Recent Users</span>
            <ul class="list-group" style="overflow-y:scroll">
              <li
                class="list-group-item d-flex justify-content-start align-items-center bg-light"
                v-for="user in lastUser"
                :key="user.id"
              >
                <div style="width:20%">
                  <span class="badge badge-primary badge-pill">{{parseDate(user.created_at)}}</span>
                </div>
                <div class="mx-3">
                  <span class="d-block">{{user.name}}</span>
                  <small class="d-block text-muted" style="word-break:break-all">{{user.email}}</small>
                </div>
              </li>
            </ul>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import AreaChart from "./graph/AreaChart";
import PieChart from "./graph/PieChart";
import BarChart from "./graph/BarChart";
import FilterBar from "@/components/table/FilterBar";
import moment from "moment";
export default {
  components: {
    AreaChart,
    PieChart,
    BarChart,
    FilterBar
  },
  data() {
    return {
      totalConversation: 0,
      totalTransaction: 0,
      totalUser: 0,
      totalAmount: 0,
      lastUser: [],

      //   for rerender
      componentKey: 0
    };
  },
  methods: {
    formatAmount(value) {
      return value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
    },
    forceRerender() {
      this.componentKey += 1;
    },
    parseDate(date) {
      return moment(date, "YYYY-MM-DD kk:mm:ss").fromNow();
    }
    // dashboardData() {
    //   return this.$store.getters["dashboard/dashboardData"];
    // }
  },
  async created() {
    await this.$store.dispatch("dashboard/getDashboardData");
    this.forceRerender();
    let dashboardData = this.$store.getters["dashboard/dashboardData"];
    this.totalConversation = dashboardData.total_conversation;
    this.totalUser = dashboardData.total_user;
    this.totalTransaction = dashboardData.total_transaction || 0;
    this.totalAmount = dashboardData.total_amount || 0;
    this.lastUser = dashboardData.last_user || [];
  }
};
</script>

<style lang="scss" scoped>
.logo-card-dashboard {
  width: 41pt;
  height: 40pt;
}
</style>
